diff -ruN ../nakedmudv3.0/src/inform.c src/inform.c
--- ../nakedmudv3.0/src/inform.c	Fri Oct  7 14:15:55 2005
+++ src/inform.c	Sun Dec  4 20:03:07 2005
@@ -30,8 +30,6 @@
 // mandatory modules
 //*****************************************************************************
 #include "items/items.h"
-#include "items/portal.h"
-#include "items/container.h"
 #include "items/furniture.h"
 
 
@@ -137,86 +135,54 @@
   // do all of the preprocessing on the new descriptions
   hookRun("preprocess_obj_desc", new_desc, obj, ch);
 
+  // append anything that might also go onto it
+  hookRun("append_obj_desc", new_desc, obj, ch);
+
   // colorize all of the edescs
   edescTagDesc(new_desc, objGetEdescs(obj), "{c", "{g");
 
   // format the desc, and send it
   bufferFormat(new_desc, SCREEN_WIDTH, PARA_INDENT);
-  send_to_char(ch, "{g%s", bufferString(new_desc));
+
+  if(bufferLength(new_desc) == 0)
+    send_to_char(ch, "{g%s\r\n", NOTHING_SPECIAL);
+  else
+    send_to_char(ch, "{g%s", bufferString(new_desc));
 
   // free up our mess
   deleteBuffer(new_desc);
 
-  // list container-related stuff
-  if(objIsType(obj, "container")) {
-    send_to_char(ch, "{g%s is %s%s.\r\n",
-		 objGetName(obj), 
-		 (containerIsClosed(obj) ? "closed" : "opened"),
-		 (containerIsLocked(obj) ? " and locked"  : ""));
-
-    // print all of our contents
-    if(listSize(objGetContents(obj)) > 0 && !containerIsClosed(obj)) {
-      LIST *vis_contents = find_all_objs(ch, objGetContents(obj), "", 
-					 NULL, TRUE);
-      // make sure we can still see things
-      if(listSize(vis_contents) > 0) {
-	send_to_char(ch, "It contains:\r\n");
-	show_list(ch, vis_contents, objGetName, objGetMultiName);
-      }
-      deleteList(vis_contents);
-    }
-  }
-
-  // list furniture-related stuff
-  else if(objIsType(obj, "furniture")) {
-    int num_sitters = listSize(objGetUsers(obj));
-
-    send_to_char(ch, "\r\n");
-
-    // print character names
-    if(num_sitters > 0) {
-      LIST *can_see = find_all_chars(ch, objGetUsers(obj), "", NULL, TRUE);
-      listRemove(can_see, ch);
-
-      char *chars = print_list(can_see, charGetName, charGetMultiName);
-      if(*chars) send_to_char(ch, "{g%s %s %s %s%s.\r\n",
-			      chars, (listSize(can_see) == 1 ? "is" : "are"),
-			      (furnitureGetType(obj)==FURNITURE_AT ? "at":"on"),
-			      objGetName(obj),
-			      (charGetFurniture(ch) == obj ? " with you" : ""));
-      deleteList(can_see);
-      free(chars);
-    }
-
-    // print out how much room there is left on the furniture
-    int seats_left = (furnitureGetCapacity(obj) - num_sitters);
-    if(seats_left > 0)
-      send_to_char(ch, "{g%s looks like it could fit %d more %s.\r\n",
-		   objGetName(obj), seats_left, 
-		   (seats_left == 1 ? "person" : "people"));
-  }
+  hookRun("look_at_obj", obj, ch);
+  send_to_char(ch, "{n");
 }
 
 
 void look_at_exit(CHAR_DATA *ch, EXIT_DATA *exit) {
-  send_to_char(ch, "{g%s", (*exitGetDesc(exit) ? exitGetDesc(exit) :
-			    NOTHING_SPECIAL"\r\n"));
-  // we have a door ... gotta print it's status
-  if(exitIsClosable(exit)) {
-    if(!*exitGetName(exit))
-      send_to_char(ch, "It is %s.\r\n", (exitIsClosed(exit) ? "closed":"open"));
-    else {
-      send_to_char(ch, "You see %s. (%s)\r\n", 
-		   exitGetName(exit), (exitIsClosed(exit) ? "closed":"open"));
-    }
-  }
+  // make the working copy of the description, and fill it up with info
+  BUFFER *desc = bufferCopy(exitGetDescBuffer(exit));
 
-  // the door is not closed, list off the people we can see as well
-  if(!exitIsClosed(exit)) {
-    ROOM_DATA *room = worldGetRoom(gameworld, exitGetTo(exit));
-    if(room != NULL)
-      list_room_contents(ch, room);
-  }
+  // do all of our preprocessing of the description before we show it
+  hookRun("preprocess_exit_desc", desc, exit, ch);
+
+  // append anything that might also go onto it
+  hookRun("append_exit_desc", desc, exit, ch);
+
+  // colorize all of the edescs
+  edescTagDesc(desc, roomGetEdescs(exitGetRoom(exit)), "{c", "{g");
+
+  // format our description
+  bufferFormat(desc, SCREEN_WIDTH, PARA_INDENT);
+
+  // if the buffer has nothing in it, send a "nothing special" message
+  if(bufferLength(desc) == 0)
+    send_to_char(ch, "{g%s\r\n", NOTHING_SPECIAL);
+  else
+    send_to_char(ch, "{g%s", bufferString(desc));
+
+  deleteBuffer(desc);
+
+  hookRun("look_at_exit", exit, ch);
+  send_to_char(ch, "{n");
 }
 
 //
@@ -292,27 +258,25 @@
 
 
 void look_at_char(CHAR_DATA *ch, CHAR_DATA *vict) {
-  // if we're an NPC, do some special work for displaying us. We don't do 
-  // dynamic descs for PCs because they will probably be describing themselves,
-  // and we don't want to give them access to the scripting language.
-  if(!charIsNPC(vict))
-    send_to_char(ch, "{g%s{n", (*charGetDesc(vict) ? 
-				charGetDesc(vict) : NOTHING_SPECIAL"\r\n"));
-  else {
-    BUFFER *new_desc = bufferCopy(charGetDescBuffer(vict));
+  BUFFER *new_desc = bufferCopy(charGetDescBuffer(vict));
 
-    // preprocess our desc before it it sent to the person
-    hookRun("preprocess_char_desc", new_desc, vict, ch);
+  // preprocess our desc before it it sent to the person
+  hookRun("preprocess_char_desc", new_desc, vict, ch);
+
+  // append anything that might also go onto it
+  hookRun("append_char_desc", new_desc, vict, ch);
     
-    // format and send it
-    bufferFormat(new_desc, SCREEN_WIDTH, PARA_INDENT);
-    send_to_char(ch, "{g%s{n", (bufferLength(new_desc) > 0 ?
-				bufferString(new_desc): NOTHING_SPECIAL"\r\n"));
+  // format and send it
+  bufferFormat(new_desc, SCREEN_WIDTH, PARA_INDENT);
 
-    // clean up our mess
-    deleteBuffer(new_desc);
-  }
-  show_body(ch, charGetBody(vict));
+  if(bufferLength(new_desc) == 0)
+    send_to_char(ch, "{g%s\r\n", NOTHING_SPECIAL);
+  else
+    send_to_char(ch, "{g%s{n", bufferString(new_desc));
+  
+  // clean up our mess
+  deleteBuffer(new_desc);
+  hookRun("look_at_char", vict, ch);
 }
 
 
@@ -329,19 +293,24 @@
   // do all of our preprocessing of the description before we show it
   hookRun("preprocess_room_desc", desc, room, ch);
 
+  // append anything that might also go onto it
+  hookRun("append_room_desc", desc, room, ch);
+
   // colorize all of the edescs
   edescTagDesc(desc, roomGetEdescs(room), "{c", "{g");
 
   // format our description
   bufferFormat(desc, SCREEN_WIDTH, PARA_INDENT);
 
-  send_to_char(ch, "{g%s", bufferString(desc));
-  list_room_exits(ch, room);
-  list_room_contents(ch, room);
+  if(bufferLength(desc) == 0)
+    send_to_char(ch, "{g%s\r\n", NOTHING_SPECIAL);
+  else
+    send_to_char(ch, "{g%s", bufferString(desc));
 
-  send_to_char(ch, "{n");
   deleteBuffer(desc);
-};
+  hookRun("look_at_room", room, ch);
+  send_to_char(ch, "{n");
+}
 
 
 
@@ -534,41 +503,9 @@
     }
 
     // is it an item?
-    else if(found_type == FOUND_OBJ)
+    else if(found_type == FOUND_OBJ || found_type == FOUND_IN_OBJ)
       look_at_obj(ch, found);
 
-    // is it something inside of an object?
-    else if(found_type == FOUND_IN_OBJ) {
-      // show the destination we're peering at
-      if(objIsType(found, "portal")) {
-	ROOM_DATA *dest = worldGetRoom(gameworld, portalGetDest(found));
-	if(dest) {
-	  send_to_char(ch, "You peer inside %s.\r\n", see_obj_as(ch, found));
-	  look_at_room(ch, dest);
-	}
-	else
-	  send_to_char(ch, 
-		       "%s is murky, and you cannot "
-		       "make out anything on the other side.\r\n",
-		       see_obj_as(ch, found));
-      }
-      else if(!objIsType(found, "container"))
-	send_to_char(ch, "%s is not a container or portal.\r\n",
-		     objGetName(found));
-      else if(containerIsClosed(found))
-	send_to_char(ch, "%s is closed.\r\n", objGetName(found));
-      else if(listSize(objGetContents(found)) == 0)
-	send_to_char(ch, "There is nothing inside of %s.\r\n", 
-		     objGetName(found));
-      else {
-	send_to_char(ch, "You peer inside of %s:\r\n", objGetName(found));
-	LIST *vis_objs = find_all_objs(ch, objGetContents(found), "", NULL,
-				       TRUE);
-	show_list(ch, vis_objs, objGetName, objGetMultiName);
-	deleteList(vis_objs);
-      }
-    }
-
     // is it another character?
     else if(found_type == FOUND_CHAR)
       look_at_char(ch, found);
@@ -840,4 +777,163 @@
     va_end(args);
     message(ch, vict, obj, vobj, hide_nosee, range, buf);
   }
+}
+
+
+
+//*****************************************************************************
+// hooks
+//*****************************************************************************
+
+//
+// appends all of our exit extra descriptions to the room description.
+void exit_append_room_hook(BUFFER *buf, ROOM_DATA *room, CHAR_DATA *ch) {
+  LIST       *exnames = roomGetExitNames(room);
+  LIST       *ex_same = newList(); // leads to room w/ same name
+  LIST       *ex_diff = newList(); // leads to room w/ diff name
+  LIST     *ex_closed = newList(); // there is a closed door blocking us
+  LIST_ITERATOR *ex_i = newListIterator(exnames);
+  char            *ex = NULL;
+
+  // figure out our exits that lead to same-room-name 
+  // or different-room-name destinations.
+  ITERATE_LIST(ex, ex_i) {
+    EXIT_DATA *exit = roomGetExit(room, ex);
+    ROOM_DATA *dest = worldGetRoom(gameworld, exitGetTo(exit));
+    if(dest && can_see_exit(ch, exit) && dirGetNum(ex) != DIR_NONE) {
+      if(exitIsClosed(exit))
+	listPut(ex_closed, ex);
+      else if(!strcasecmp(roomGetName(room), roomGetName(dest)))
+	listPush(ex_same, ex);
+      else
+	listQueue(ex_diff, ex);
+    }
+  } deleteListIterator(ex_i);
+
+  // append info for dirs that are blocked by doors
+  ex_i = newListIterator(ex_closed);
+  ITERATE_LIST(ex, ex_i) {
+    EXIT_DATA *exit = roomGetExit(room, ex);
+    bprintf(buf, " %s%s, you see %s.",
+	    (dirGetNum(ex) == DIR_NONE ? "At the exit " : ""), ex,
+	    (*exitGetName(exit) ? exitGetName(exit) : "a door"));
+  } deleteListIterator(ex_i);
+
+  // append info for dirs that exit to other room names
+  ex_i = newListIterator(ex_diff);
+  ITERATE_LIST(ex, ex_i) {
+    ROOM_DATA *dest = worldGetRoom(gameworld, exitGetTo(roomGetExit(room, ex)));
+    bprintf(buf, " Continuing %s would take you to %s.", ex, roomGetName(dest));
+  } deleteListIterator(ex_i);
+
+  // and now print stuff for exits that go to rooms with the name name
+  if(listSize(ex_same) > 0) {
+    // if we just have a couple exits, list them off
+    if(listSize(ex_same) <= 3) {
+      char *list = print_list(ex_same, identity_func, NULL);
+      bprintf(buf, " %s continues %s.", roomGetName(room), list);
+      free(list);
+    }
+    // else display in bulk
+    else {
+      bprintf(buf, " All %sdiretions continue to %s.", 
+	      (listSize(ex_same) == listSize(exnames) ? "" : "other "),
+	      roomGetName(room));
+    }
+  }
+
+  // clean up our garbage
+  deleteList(ex_diff);
+  deleteList(ex_same);
+  deleteList(ex_closed);
+  deleteListWith(exnames, free);
+}
+
+void exit_append_hook(BUFFER *buf, EXIT_DATA *exit, CHAR_DATA *ch) {
+  // before anything, figure out some basic information like our dir and dest
+  ROOM_DATA     *room = exitGetRoom(exit);
+  ROOM_DATA     *dest = worldGetRoom(gameworld, exitGetTo(exit));
+  LIST       *exnames = roomGetExitNames(room);
+  LIST_ITERATOR *ex_i = newListIterator(exnames);
+  char            *ex = NULL;
+  char           *dir = NULL;
+
+  // figure out which direction we came from
+  ITERATE_LIST(ex, ex_i) {
+    if(roomGetExit(room, ex) == exit) {
+      dir = strdup(ex);
+      break;
+    }
+  } deleteListIterator(ex_i);
+  deleteListWith(exnames, free);
+
+  // tell us where it would take us
+  if(dest && !*exitGetDesc(exit) && !exitIsClosed(exit)) {
+    if(!strcasecmp(roomGetName(dest), roomGetName(room)))
+      bprintf(buf, " %s continues %s.", roomGetName(dest), dir);
+    else 
+      bprintf(buf, " Continuing %s would take you to %s.", dir, 
+	      roomGetName(dest));
+  }
+
+  // we have a door ... gotta print its status
+  if(exitIsClosable(exit)) {
+    bprintf(buf, " %s%s, you see %s which is currently %s.",
+	    (dirGetNum(dir) == DIR_NONE ? "At the exit " : ""), dir,
+	    (*exitGetName(exit) ? exitGetName(exit) : "a door"),
+	    (exitIsClosed(exit) ? "closed" : "open"));
+  }
+
+  // garbage collection
+  if(dir) free(dir);
+}
+
+void exit_look_hook(EXIT_DATA *exit, CHAR_DATA *ch) {
+  // the door is not closed, list off the people we can see as well
+  if(!exitIsClosed(exit)) {
+    ROOM_DATA *room = worldGetRoom(gameworld, exitGetTo(exit));
+    if(room != NULL)
+      list_room_contents(ch, room);
+  }
+}
+
+void body_look_hook(CHAR_DATA *vict, CHAR_DATA *ch) {
+  send_to_char(ch, "\r\n{g%s %s wearing:\r\n", 
+	       (ch == vict ? "You" : HESHE(vict)),
+	       (ch == vict ? "are" : "is"));
+  show_body(ch, charGetBody(vict));
+}
+
+void room_look_hook(ROOM_DATA *room, CHAR_DATA *ch) {
+  list_room_exits(ch, room);
+  list_room_contents(ch, room);
+}
+
+
+
+//*****************************************************************************
+// initialization of inform.h
+//*****************************************************************************
+void init_inform(void) {
+  // add all of our hook types
+  hook_add_handler("preprocess_room_desc", hook_handler_3_args);
+  hook_add_handler("preprocess_obj_desc",  hook_handler_3_args);
+  hook_add_handler("preprocess_char_desc", hook_handler_3_args);
+  hook_add_handler("preprocess_exit_desc", hook_handler_3_args);
+  hook_add_handler("append_room_desc",     hook_handler_3_args);
+  hook_add_handler("append_obj_desc",      hook_handler_3_args);
+  hook_add_handler("append_char_desc",     hook_handler_3_args);
+  hook_add_handler("append_exit_desc",     hook_handler_3_args);
+  hook_add_handler("look_at_room",         hook_handler_2_args);
+  hook_add_handler("look_at_obj",          hook_handler_2_args);
+  hook_add_handler("look_at_char",         hook_handler_2_args);
+  hook_add_handler("look_at_exit",         hook_handler_2_args);
+
+  // attach hooks
+  hookAdd("append_exit_desc", exit_append_hook);
+  // enable if you want exits to append to the end of room descs
+  //  hookAdd("append_room_desc", exit_append_room_hook);
+  hookAdd("look_at_exit",     exit_look_hook);
+  hookAdd("look_at_char",     body_look_hook);
+  hookAdd("look_at_room",     room_look_hook);
 }
diff -ruN ../nakedmudv3.0/src/inform.h src/inform.h
--- ../nakedmudv3.0/src/inform.h	Fri Oct  7 14:15:55 2005
+++ src/inform.h	Sun Dec  4 20:03:07 2005
@@ -10,6 +10,11 @@
 //
 //*****************************************************************************
 
+//
+// lots of informative stuff needs to be initialized. Do that before the
+// information functions are used.
+void init_inform(void);
+
 
 
 //********************
diff -ruN ../nakedmudv3.0/src/interpret.c src/interpret.c
--- ../nakedmudv3.0/src/interpret.c	Fri Oct  7 14:15:55 2005
+++ src/interpret.c	Sun Dec  4 20:03:07 2005
@@ -392,7 +392,8 @@
 #endif
 
   // first try room commands then world commands
-  if(!try_use_cmd_table(ch,roomGetCmdTable(charGetRoom(ch)),command,arg,FALSE))
+  if(!charGetRoom(ch) || 
+     !try_use_cmd_table(ch,roomGetCmdTable(charGetRoom(ch)),command,arg,FALSE))
     if(!try_use_cmd_table(ch, cmd_table, command, arg, TRUE))
       text_to_char(ch, "No such command.\r\n");
 }
diff -ruN ../nakedmudv3.0/src/items/container.c src/items/container.c
--- ../nakedmudv3.0/src/items/container.c	Fri Oct  7 14:15:55 2005
+++ src/items/container.c	Sun Dec  4 20:03:07 2005
@@ -13,6 +13,8 @@
 #include "../world.h"
 #include "../socket.h"
 #include "../utils.h"
+#include "../hooks.h"
+#include "../inform.h"
 #include "../olc2/olc.h"
 
 #include "items.h"
@@ -495,6 +497,31 @@
 
 
 //*****************************************************************************
+// hooks
+//*****************************************************************************
+void container_append_hook(BUFFER *desc, OBJ_DATA *obj, CHAR_DATA *ch) {
+  if(objIsType(obj, "container")) {
+    bprintf(desc, " It is %s%s.", (containerIsClosed(obj) ? "closed":"open"),
+	    (containerIsLocked(obj) ? " and locked" : ""));
+  }
+}
+
+void container_look_hook(OBJ_DATA *obj, CHAR_DATA *ch) {
+  if(objIsType(obj, "container") && !containerIsClosed(obj)) {
+    LIST *vis_contents = find_all_objs(ch, objGetContents(obj), "", 
+				       NULL, TRUE);
+      // make sure we can still see things
+      if(listSize(vis_contents) > 0) {
+	send_to_char(ch, "It contains:\r\n");
+	show_list(ch, vis_contents, objGetName, objGetMultiName);
+      }
+      deleteList(vis_contents);
+  }
+}
+
+
+
+//*****************************************************************************
 // install the container item type
 //*****************************************************************************
 
@@ -505,6 +532,10 @@
   		newContainerData, deleteContainerData,
   		containerDataCopyTo, containerDataCopy, 
   		containerDataStore, containerDataRead);
+
+  // add our hooks
+  hookAdd("append_obj_desc", container_append_hook);
+  hookAdd("look_at_obj",     container_look_hook);
 
   // set up the container OLC too
   item_add_olc("container", iedit_container_menu, iedit_container_chooser, 
diff -ruN ../nakedmudv3.0/src/items/furniture.c src/items/furniture.c
--- ../nakedmudv3.0/src/items/furniture.c	Fri Oct  7 14:15:55 2005
+++ src/items/furniture.c	Sun Dec  4 20:03:07 2005
@@ -10,9 +10,11 @@
 #include "../mud.h"
 #include "../utils.h"
 #include "../storage.h"
+#include "../character.h"
 #include "../object.h"
 #include "../world.h"
 #include "../socket.h"
+#include "../hooks.h"
 #include "../olc2/olc.h"
 
 #include "items.h"
@@ -271,6 +273,38 @@
 
 
 //*****************************************************************************
+// hooks
+//*****************************************************************************
+void furniture_append_hook(BUFFER *buf, OBJ_DATA *obj, CHAR_DATA *ch) {
+  if(objIsType(obj, "furniture")) {
+    int num_sitters = listSize(objGetUsers(obj));
+
+    // print out how much room there is left on the furniture
+    int seats_left = (furnitureGetCapacity(obj) - num_sitters);
+    if(seats_left > 0)
+      bprintf(buf, " It looks like it could fit %d more %s.\r\n",
+		   seats_left, (seats_left == 1 ? "person" : "people"));
+
+    // print character names
+    if(num_sitters > 0) {
+      LIST *can_see = find_all_chars(ch, objGetUsers(obj), "", NULL, TRUE);
+      listRemove(can_see, ch);
+
+      char *chars = print_list(can_see, charGetName, charGetMultiName);
+      if(*chars) bprintf(buf, "%s %s %s %s%s.\r\n",
+			 chars, (listSize(can_see) == 1 ? "is" : "are"),
+			 (furnitureGetType(obj) == FURNITURE_AT ? "at":"on"),
+			 see_obj_as(ch, obj),
+			 (charGetFurniture(ch) == obj ? " with you" : ""));
+      deleteList(can_see);
+      free(chars);
+    }
+  }
+}
+
+
+
+//*****************************************************************************
 // install the furniture item type
 //*****************************************************************************
 
@@ -281,6 +315,9 @@
   		newFurnitureData, deleteFurnitureData,
   		furnitureDataCopyTo, furnitureDataCopy, 
   		furnitureDataStore, furnitureDataRead);
+
+  // add our hooks
+  hookAdd("append_obj_desc", furniture_append_hook);
 
   // set up the furniture OLC too
   item_add_olc("furniture", iedit_furniture_menu, iedit_furniture_chooser, 
diff -ruN ../nakedmudv3.0/src/items/portal.c src/items/portal.c
--- ../nakedmudv3.0/src/items/portal.c	Fri Oct  7 14:15:55 2005
+++ src/items/portal.c	Sun Dec  4 20:03:07 2005
@@ -18,10 +18,12 @@
 #include "../movement.h"
 #include "../inform.h"
 #include "../handler.h"
+#include "../hooks.h"
 #include "items.h"
 
 #include "../olc2/olc.h"
 #include "iedit.h"
+#include "portal.h"
 
 
 
@@ -38,23 +40,34 @@
 // item data for portals
 //*****************************************************************************
 typedef struct portal_data {
-  char *dest;
+  char        *dest;
+  char  *leave_mssg;
+  char  *enter_mssg;
 } PORTAL_DATA;
 
 PORTAL_DATA *newPortalData() {
   PORTAL_DATA *data = malloc(sizeof(PORTAL_DATA));
-  data->dest = strdup("");
+  data->dest       = strdup("");
+  data->leave_mssg = strdup("");
+  data->enter_mssg = strdup("");
   return data;
 }
 
 void deletePortalData(PORTAL_DATA *data) {
-  if(data->dest) free(data->dest);
+  if(data->dest)       free(data->dest);
+  if(data->leave_mssg) free(data->leave_mssg);
+  if(data->enter_mssg) free(data->enter_mssg);
   free(data);
 }
 
 void portalDataCopyTo(PORTAL_DATA *from, PORTAL_DATA *to) {
-  if(to->dest) free(to->dest);
-  to->dest = strdupsafe(from->dest);
+  if(to->dest)       free(to->dest);
+  if(to->leave_mssg) free(to->leave_mssg);
+  if(to->enter_mssg) free(to->enter_mssg);
+  to->dest       = strdupsafe(from->dest);
+  to->leave_mssg = strdupsafe(from->leave_mssg);
+  to->enter_mssg = strdupsafe(from->enter_mssg);
+  
 }
 
 PORTAL_DATA *portalDataCopy(PORTAL_DATA *data) {
@@ -65,13 +78,17 @@
 
 STORAGE_SET *portalDataStore(PORTAL_DATA *data) {
   STORAGE_SET *set = new_storage_set();
-  store_string(set, "dest", data->dest);
+  store_string(set, "dest",  data->dest);
+  store_string(set, "enter", data->enter_mssg);
+  store_string(set, "leave", data->leave_mssg);
   return set;
 }
 
 PORTAL_DATA *portalDataRead(STORAGE_SET *set) {
-  PORTAL_DATA *data = newPortalData();
-  data->dest = strdup(read_string(set, "dest"));
+  PORTAL_DATA *data = malloc(sizeof(PORTAL_DATA));
+  data->dest        = strdupsafe(read_string(set, "dest"));
+  data->enter_mssg  = strdupsafe(read_string(set, "enter"));
+  data->leave_mssg  = strdupsafe(read_string(set, "leave"));
   return data;
 }
 
@@ -85,12 +102,34 @@
   return data->dest;
 }
 
+const char *portalGetLeaveMssg(OBJ_DATA *obj) {
+  PORTAL_DATA *data = objGetTypeData(obj, "portal");
+  return data->leave_mssg;
+}
+
+const char *portalGetEnterMssg(OBJ_DATA *obj) {
+  PORTAL_DATA *data = objGetTypeData(obj, "portal");
+  return data->enter_mssg;
+}
+
 void portalSetDest(OBJ_DATA *obj, const char *dest) {
   PORTAL_DATA *data = objGetTypeData(obj, "portal");
   if(data->dest) free(data->dest);
   data->dest = strdupsafe(dest);
 }
 
+void portalSetLeaveMssg(OBJ_DATA *obj, const char *mssg) {
+  PORTAL_DATA *data = objGetTypeData(obj, "portal");
+  if(data->leave_mssg) free(data->leave_mssg);
+  data->leave_mssg = strdupsafe(mssg);
+}
+
+void portalSetEnterMssg(OBJ_DATA *obj, const char *mssg) {
+  PORTAL_DATA *data = objGetTypeData(obj, "portal");
+  if(data->enter_mssg) free(data->enter_mssg);
+  data->enter_mssg = strdupsafe(mssg);
+}
+
 
 //
 // cmd_enter is used to go through portals
@@ -102,14 +141,12 @@
   void    *found = NULL;
   int found_type = PARSE_NONE;
 
-  if(!parse_args(ch, TRUE, cmd, arg, "{ obj.room exit } ", &found, &found_type))
+  if(!parse_args(ch, TRUE, cmd, arg, "{ obj.room exit }", &found, &found_type))
     return;
 
   // we're trying to enter an exit
-  if(found_type == PARSE_EXIT) {
-    if(try_move_mssg(ch, roomGetExitDir(charGetRoom(ch), found)))
-      look_at_room(ch, charGetRoom(ch));
-  }
+  if(found_type == PARSE_EXIT)
+    try_move_mssg(ch, roomGetExitDir(charGetRoom(ch), found));
 
   // we're trying to enter a portal
   else {
@@ -120,14 +157,21 @@
       if(dest == NULL)
 	send_to_char(ch, "There is nothing on the other side...\r\n");
       else {
-	send_to_char(ch, "You step through %s.\r\n", see_obj_as(ch, found));
-	message(ch, NULL, found, NULL, TRUE, TO_ROOM,
-		"$n steps through $o.");
+	if(*portalGetLeaveMssg(found))
+	  message(ch, NULL, found,NULL,TRUE,TO_ROOM, portalGetLeaveMssg(found));
+	else
+	  message(ch, NULL, found, NULL, TRUE, TO_ROOM, "$n steps into $o.");
+
+	// transfer our character and look
 	char_from_room(ch);
 	char_to_room(ch, dest);
 	look_at_room(ch, dest);
-	message(ch, NULL, found, NULL, TRUE, TO_ROOM,
-		"$n arrives after travelling through $o.");
+
+	if(*portalGetEnterMssg(found))
+	  message(ch, NULL, found,NULL,TRUE,TO_ROOM, portalGetEnterMssg(found));
+	else
+	  message(ch, NULL, found, NULL, TRUE, TO_ROOM,
+		  "$n arrives after travelling through $o.");
       }
     }
   }
@@ -139,10 +183,14 @@
 // portal olc
 //*****************************************************************************
 #define IEDIT_PORTAL_DEST      1
+#define IEDIT_PORTAL_ENTER     2
+#define IEDIT_PORTAL_LEAVE     3
 
 // the resedit olc needs these declared
-void iedit_portal_menu   (SOCKET_DATA *sock, PORTAL_DATA *data) {
-  send_to_socket(sock, "{g1) Destination: {c%s\r\n", data->dest);
+void iedit_portal_menu(SOCKET_DATA *sock, PORTAL_DATA *data) {
+  send_to_socket(sock, "{g1) Destination  : {c%s\r\n", data->dest);
+  send_to_socket(sock, "{g2) Enter message:\r\n{c%s\r\n", data->enter_mssg);
+  send_to_socket(sock, "{g3) Leave message:\r\n{c%s\r\n", data->leave_mssg);
 }
 
 int  iedit_portal_chooser(SOCKET_DATA *sock, PORTAL_DATA *data, 
@@ -151,6 +199,12 @@
   case '1': 
     text_to_buffer(sock, "Enter new destination (return for none): ");
     return IEDIT_PORTAL_DEST;
+  case '2':
+    text_to_buffer(sock, "Enter message shown to room user arrives at: ");
+    return IEDIT_PORTAL_ENTER;
+  case '3':
+    text_to_buffer(sock, "Enter message shown to room user leaves: ");
+    return IEDIT_PORTAL_LEAVE;
   default:
     return MENU_CHOICE_INVALID;
   }
@@ -164,24 +218,59 @@
     data->dest   = strdupsafe(arg);
     return TRUE;
   }
+  case IEDIT_PORTAL_LEAVE: {
+    if(data->leave_mssg) free(data->leave_mssg);
+    data->leave_mssg = strdupsafe(arg);
+    return TRUE;
+  }
+  case IEDIT_PORTAL_ENTER: {
+    if(data->enter_mssg) free(data->enter_mssg);
+    data->enter_mssg = strdupsafe(arg);
+    return TRUE;
+  }
   default:
     return FALSE;
   }
 }
 
 void portal_from_proto(PORTAL_DATA *data, BUFFER *buf) {
-  if(*bufferString(buf)) {
-    char dest[SMALL_BUFFER];
-    sscanf(bufferString(buf), "me.portal_dest = \"%s", dest);
-    dest[next_letter_in(dest, '\"')] = '\0'; // kill closing "
-    if(data->dest) free(data->dest);
-    data->dest = strdupsafe(dest);
-  }
+  char line[MAX_BUFFER];
+  const char *code = bufferString(buf);
+  do {
+    code = strcpyto(line, code, '\n');
+    char *lptr = line;
+    if(!strncasecmp(lptr, "me.portal_dest", 14)) {
+      while(*lptr && *lptr != '\"') lptr++;
+      lptr++; // skip leading "
+      lptr[next_letter_in(lptr, '\"')] = '\0'; // kill ending "
+      if(data->dest) free(data->dest);
+      data->dest = strdupsafe(lptr);
+    }
+    else if(!strncasecmp(lptr, "me.portal_enter_mssg", 20)) {
+      while(*lptr && *lptr != '\"') lptr++;
+      lptr++; // skip leading "
+      lptr[next_letter_in(lptr, '\"')] = '\0'; // kill ending "
+      if(data->enter_mssg) free(data->enter_mssg);
+      data->enter_mssg = strdupsafe(lptr);
+    }
+    else if(!strncasecmp(lptr, "me.portal_leave_mssg", 20)) {
+      while(*lptr && *lptr != '\"') lptr++;
+      lptr++; // skip leading "
+      lptr[next_letter_in(lptr, '\"')] = '\0'; // kill ending "
+      if(data->leave_mssg) free(data->leave_mssg);
+      data->leave_mssg = strdupsafe(lptr);
+    }
+    else; // ignore line
+  } while(*code != '\0');
 }
 
 void portal_to_proto(PORTAL_DATA *data, BUFFER *buf) {
   if(*data->dest)
     bprintf(buf, "me.portal_dest = \"%s\"\n", data->dest);
+  if(*data->leave_mssg)
+    bprintf(buf, "me.portal_leave_mssg = \"%s\"\n", data->leave_mssg);
+  if(*data->enter_mssg)
+    bprintf(buf, "me.portal_enter_mssg = \"%s\"\n", data->enter_mssg);
 }
 
 
@@ -201,6 +290,30 @@
   }
 }
 
+PyObject *PyObj_getportalleavemssg(PyObject *self, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj(self);
+  if(obj == NULL)
+    return NULL;
+  else if(objIsType(obj, "portal"))
+    return Py_BuildValue("s", portalGetLeaveMssg(obj));
+  else {
+    PyErr_Format(PyExc_TypeError, "Can only get leave message for portals.");
+    return NULL;
+  }
+}
+
+PyObject *PyObj_getportalentermssg(PyObject *self, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj(self);
+  if(obj == NULL)
+    return NULL;
+  else if(objIsType(obj, "portal"))
+    return Py_BuildValue("s", portalGetEnterMssg(obj));
+  else {
+    PyErr_Format(PyExc_TypeError, "Can only get enter message for portals.");
+    return NULL;
+  }
+}
+
 int PyObj_setportaldest(PyObject *self, PyObject *value, void *closure) {
   OBJ_DATA *obj = PyObj_AsObj(self);
   if(obj == NULL) {
@@ -226,6 +339,67 @@
   return 0;
 }
 
+int PyObj_setportalleavemssg(PyObject *self, PyObject *value, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj(self);
+  if(obj == NULL) {
+    PyErr_Format(PyExc_StandardError, "Tried to set leave message for "
+		 "nonexistent portal, %d", PyObj_AsUid(self));
+    return -1;
+  }
+  else if(!objIsType(obj, "portal")) {
+    PyErr_Format(PyExc_TypeError, "Tried to set leave mssg for non-portal, %s",
+		 objGetClass(obj));
+    return -1;
+  }
+
+  if(PyString_Check(value))
+    portalSetLeaveMssg(obj, PyString_AsString(value));
+  else {
+    PyErr_Format(PyExc_TypeError, "portal leave message must be a string.");
+    return -1;
+  }
+
+  return 0;
+}
+
+int PyObj_setportalentermssg(PyObject *self, PyObject *value, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj(self);
+  if(obj == NULL) {
+    PyErr_Format(PyExc_StandardError, "Tried to set enter message for "
+		 "nonexistent portal, %d", PyObj_AsUid(self));
+    return -1;
+  }
+  else if(!objIsType(obj, "portal")) {
+    PyErr_Format(PyExc_TypeError, "Tried to set enter mssg for non-portal, %s",
+		 objGetClass(obj));
+    return -1;
+  }
+
+  if(PyString_Check(value))
+    portalSetEnterMssg(obj, PyString_AsString(value));
+  else {
+    PyErr_Format(PyExc_TypeError, "portal enter message must be a string.");
+    return -1;
+  }
+
+  return 0;
+}
+  
+
+
+//*****************************************************************************
+// add our hookds
+//*****************************************************************************
+void portal_look_hook(OBJ_DATA *obj, CHAR_DATA *ch) {
+  if(objIsType(obj, "portal")) {
+    ROOM_DATA *dest = worldGetRoom(gameworld, portalGetDest(obj));
+    if(dest != NULL) {
+      send_to_char(ch, "You peer inside %s.\r\n", see_obj_as(ch, obj));
+      look_at_room(ch, dest);
+    }
+  }
+}
+
 
 
 //*****************************************************************************
@@ -240,6 +414,9 @@
 		portalDataCopyTo, portalDataCopy, 
 		portalDataStore, portalDataRead);
 
+  // set up our hooks
+  hookAdd("look_at_obj", portal_look_hook);
+
   // set up the portal OLC too
   item_add_olc("portal", iedit_portal_menu, iedit_portal_chooser, 
 	       iedit_portal_parser, portal_from_proto, portal_to_proto);
@@ -247,6 +424,12 @@
   // make it so we can set portal destinations in scripts
   PyObj_addGetSetter("portal_dest", PyObj_getportaldest, PyObj_setportaldest,
 		     "the database key of the room we're going to.");
+  PyObj_addGetSetter("portal_enter_mssg", 
+		     PyObj_getportalentermssg, PyObj_setportalentermssg,
+		     "The message shown when user enters a new room.");
+  PyObj_addGetSetter("portal_leave_mssg", 
+		     PyObj_getportalleavemssg, PyObj_setportalleavemssg,
+		     "The message shown when user leaves a room.");
 
   add_cmd("enter", NULL, cmd_enter, POS_STANDING, POS_FLYING,
 	  "player", TRUE, TRUE);
diff -ruN ../nakedmudv3.0/src/items/portal.h src/items/portal.h
--- ../nakedmudv3.0/src/items/portal.h	Fri Oct  7 14:15:55 2005
+++ src/items/portal.h	Sun Dec  4 20:03:07 2005
@@ -12,10 +12,14 @@
 
 //
 // return the key of the room that the portal leads to
-const char *portalGetDest(OBJ_DATA *obj);
+const char      *portalGetDest(OBJ_DATA *obj);
+const char *portalGetLeaveMssg(OBJ_DATA *obj);
+const char *portalGetEnterMssg(OBJ_DATA *obj);
 
 //
 // set the destination of the portal
-void portalSetDest(OBJ_DATA *obj, const char *dest);
+void      portalSetDest(OBJ_DATA *obj, const char *dest);
+void portalSetLeaveMssg(OBJ_DATA *obj, const char *mssg);
+void portalSetEnterMssg(OBJ_DATA *obj, const char *mssg);
 
 #endif // PORTAL_H
